/*
values.h: Contains Data structure
Copyright (c) 2000 Narayan Natarajan

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.



*/

#include <stdio.h>
#include <time.h>
#include <ctype.h>
/*#include <fcntl.h>*/

typedef struct {
	int day;
	int month;
	int year;
} Date;

typedef struct {
	short byte;
	char string[4096];         /* note has a limit of 4096 characters    */
} CString;                     /* I am not 100% sure but I tested it on  */
                               /* on the pil.desk. and it truncated when */
                               /* it hit around 4057 or so. So I am      */
                               /* limiting note to 4000 characters. So   */
                               /* don't start writing an Illiad, Homer!  */
typedef struct {
	long noc;                  /* Number of Categories: zero seems to work*/
	long lindex, lid, lname;   /*  No clue what these are. I copied them from 
	                               my pilot datebook.dba and it works..
	                               so far!
							   */
	long unknown[11];          /* Some 10/11 values I have no clue about.
	                              Set values from Nico Seesle's web page */
} Category;

typedef struct {
	long lrepeat;
	long lunknown;
	long lstrleng;
	char creptype[BUFSIZ];    /* strings: CDateOfYear, CDateOfMonth */
	long lreptype;
	long lfreq;
	long lenddate;
	long lcustom[3];
	char days;


} Repeat_event;


typedef struct {
	long field[20];
	long lrec_id;
	long lstat;
	long lpos;
	time_t start_time, end_time;
	CString description;
	long lduration;
	CString note;
	long luntimed;
	long lprivate;
	long lcategory;
	long lalarmset;
	long lalarmadv;
	long lalarmadvtype;
	Repeat_event repeat;
} Datebook_entry;


typedef struct {
	long discard;
	CString GHeader; /* This holds the filename of the file itself */
	CString SHeader; /* This holds the id as a string: completely useless.
						Zero as the length and no string seems to work */
	Category category;
	long nrec;       /* Number of records times 15, where'd they get 15?!! */
	Datebook_entry *datebook;

} Datebook;



#define DAY_OF_MONTH "Day"
#define DATE_OF_YEAR "Date"
#define MEM_CHUNK 50

/* from rdflexdb.c */
#define DATE_IN_MTH 'd'  /* d ate */
#define YEAR 'y'         /* y ear */
#define MONTH 'm'        /* m onth */
#define START_HOUR 'h'   /* h our */
#define START_MIN 'i'    /* m in */
#define END_HOUR 'e'     /* e nd hour */
#define END_MIN 'f'      /* f f follows e min */
#define DURATION 't'     /* t ime span: duration*/
#define EVENT 'v'        /* e v ent*/
#define REPEAT 'r'       /* r epeat */
#define ST_TIME_FMT 'a'  /* a am/pm start */
#define END_TIME_FMT 'b' /* b am/pm end  */
#define PRIVATE 'p'      /* p rivate */
#define UNTIMED 'u'      /* u ntimed events */
#define MULTILINE 'n'    /* n note, multi-line field for note only */

/* a % sign is the indicator for the start of a field definer 
 store every character coming through, soon as we recv a % 
mark it
lets say:
junk -- 0
one of the above types of fields -- appropriate character


DEFINITELY REQUIRED FIELDS:
defaults	year=current year, duration=1hr, repeat=none, start_min=0
month	date	start_hour	event


so figure all the other stuff out and create a tab delimited string
for the convdb to process. Its less confusing this way, until convdb
is rewritten.


*/
typedef struct {
 	char field[100]; /*allows 10 chars each at most */
 	char val;       /*contains either a 0 or char corr to fld */
} Recdef; 



